;
/**
 *  App 基础类
 * @param {Object} $ mui对象
 * @param {Object} w window 对象
 * @param {Object} app 自定义对象
 */
(function($, w, app) {
	var core = new Object();
	var data = new Object();
	var provider = new Object();
	core.Url="http://www.616wan.cn/";
//	core.Url="http://192.168.0.7/";
	core.update="http://www.616wan.cn/AppDown/ApkDownloading"
	/**
	 *  服务器请求操作
	 * @param {Object} url
	 * @param {Object} type
	 * @param {Object} data
	 * @param {Object} beforcall
	 * @param {Object} callback
	 * @param {Object} errorback
	 * @param {String} datatype Json,text,Html
	 */
	provider.ajax = function(url, type, data, beforcall, callback, errorback,datatype) {
		type = type || "GET";
		data = data || "";
		datatype= datatype || "json";
		header = core.getHeader();
		beforcall = beforcall || $.noop;
		errorback = errorback || $.noop;
		var settings = {
			type: type,
			data: data,
			headers: header,
			dataType: datatype,
			timeout: 120,
			async: false,
			success: callback,
			error: errorback,
			beforeSend: beforcall
		}
		app.log("provider.ajax.url:" + url);
		app.log("provider.ajax.settings:" + JSON.stringify(settings));
		$.ajax(url, settings);
	}

	data.use = null;
	data.user = null;
	data.Cache = function() {
		
	}

	app.config = {
		debug: true
	};

	/**
	 * 日志输出
	 * @param {Object} message
	 */
	app.log = function(message) {
		if(app.config.debug) {
			console.log(message);
		}
	}

	core.settings = {
		version: "1.0.0",
		appName: "GovApplication",
		appKey: "leyougame",
		appSecret: "56CACD4F-31F1-4159-AF0F-33F1B89E806C",
		appProject: "WeProject",
		appId:"1",
	};


	core.Post = function(url, data, beforcall, callback) {
		provider.ajax(url, "POST", data, beforcall, callback, null);
	}

	core.ajax = function(url, type, data, callBack, CallError,datatype) {
		var t = type || "GET";
		provider.ajax(url, type, data, $.noop, callBack, CallError,datatype);
	}
	function getCacheUserId(){
		var cache=localStorage.getItem("userInfo");
				var userId=null;
				if(cache!=null)
				{
					userId=JSON.parse(cache).Id;
				};
				console.log(userId);
				
		return userId;
	}
	
	function getMobileType()
	{
		var MobileType
		if(plus.os.name=="Android")
		{
			MobileType=2;
		}else{
			MobileType=1;
		}
		return MobileType;
	}
	
	
	core.getHeader = function() {
		var timestamp = app.getTimeStamp();
		var value = "AppKey=" + core.settings.appKey + "&AppSecret=" + core.settings.appSecret.toLowerCase() + "&TimeStamp=" + timestamp;
		console.log("没加密前的值=============="+value)
		var signature = hex_md5(value.toLowerCase()).toUpperCase(); //转换为小写加密，后转换成大写
		return {
			"appkey": core.settings.appKey,
			"TimeStamp": timestamp,
			"appsecret": core.settings.appSecret,
			"signature":signature,
			"appid":core.settings.appId,
			"appuserid":getCacheUserId(),
			"appmobiletype":getMobileType()
		};
	}
	
	app.getTimeStamp = function() {
		var datetime = new Date();
		return Math.round(datetime.getTime() / 1000);
	}

	
	

	/**
	 * 获取验证码
	 */
	core.code = function(phone,elem) {
		var result = "";
		core.ajax(app.core.Url+"AppCommon/SendCode", "POST",{phone:phone},function(result) {
			if(!result.success){
				mui.alert(result.msg);
			}
		}, function(xhr, type, error) {
			plus.nativeUI.confirm(error, function(event) {
				if(event.index == 0) {

				} else if(event.index == 1) {

				}
			}, "登陆错误！", ["取消", "确定"]);
		});
	
	}

	var user = new Object();
	user.settings = {
		
	}
	
	/**
	 * 用户登陆方法
	 * @param {String}} userName 登陆账号
	 * @param {String} password 登陆密码
	 * @param {Boolean} isAutch 是否自动登陆
	 * @return {Boolean} True:登陆成功，False:登陆失败。
	 */
	user.login = function(LoginName, password,ele) {
		var userInfo = {};
		if(LoginName == null || LoginName.length <= 0) {
			plus.nativeUI.toast("手机号码不能为空！");
			return false;
		}
		if(password == null || password.length <= 0) {
			plus.nativeUI.toast("用户密码不能为空！");
			return false;
		}
		console.log(ele);
		ele.setAttribute("disabled","disabled");
		var nwaiting = plus.nativeUI.showWaiting();
		core.ajax(app.core.Url+"AppCustomer/Login", "POST", {
			loginName: LoginName,
			password: password
		},function(result) {
			nwaiting.close();
			ele.removeAttribute("disabled");
			console.log(JSON.stringify(result));
			if(result.success==true)
			{
				console.log(result.data.ID+result.data.LoginName+result.data.LoginPassword)
				userInfo.Id=result.data.ID;
				userInfo.Name=result.data.Name;
				userInfo.Balance=result.data.Balance;
				userInfo.Phone=result.data.Phone;
				userInfo.Experience=result.data.Experience;
				userInfo.Points=result.data.Points;
				localStorage.setItem("userInfo",JSON.stringify(userInfo));
				console.log(localStorage.getItem("userInfo")+"获取缓存");
				mui.back();
			}else{
				mui.alert(result.msg)
			}
		}, function(xhr, type, error) {
			plus.nativeUI.confirm(error, function(event) {
				if(event.index == 0) {

				} else if(event.index == 1) {

				}
			}, "登陆错误！", ["取消", "确定"]);
		});
	
	}

	
	
	/**
	 * 用户注册方法
	 * @param {StringJSON} useInfo 用户基本信息
	 */
	user.register = function(userInfo,ele) {
		var result = false;
		if(userInfo.phone=="")
		{
			mui.toast("手机账号不能为空");
			return;
		}
		if(userInfo.password=="")
		{
			mui.toast("密码不能为空");
			return;
		}
		if(userInfo.password.length<6)
		{
			mui.toast("密码长度不能小于6位");
			return;
		}
		if(userInfo.password!=userInfo.confirmPassword)
		{
			mui.toast("您两次输入的密码不一致");
			return;
		}
		
		if(userInfo.code=="")
		{
			mui.toast("验证码不能为空");
			return;
		}
			ele.setAttribute("disabled","disabled");
			core.ajax(app.core.Url+"AppCustomer/Registered","Get",{password:userInfo.password,phone:userInfo.phone,code:userInfo.code}, function(data) {
				console.log(JSON.stringify(data))
				ele.removeAttribute("disabled");
				if(data.success==true)
				{
					mui.toast("注册成功");
					mui.openWindow({
						url:"login.html",
						id:"login.html",
					})
				}else{
					mui.alert(data.msg);
				}
			}, function(xhr, type, errorthrown) {
				console.log(errorthrown);
				var cfm = -1;
				plus.nativeUI.confirm(errorthrown, function(event) {
					cfm = event.index;
					//处理错误代码
				}, "注册错误！", ["取消", "确定"]);
			});
		
	}
	
	
	
	/**
	 * 用户修改头像
	 * @param {Object} userId 用户编号
	 * @param {Object} headerUrl 头像Url地址
	 * @return {Boolean}
	 */
	user.changeHeader = function(userId, headerUrl) {

	}

	/**
	 * 修改个人基本信息
	 * @param {Object} userInfo 信息基本信息
	 * @return {Boolean} True:修改成功，False:修改失败
	 */
	user.modifyInfo = function(userInfo) {
		
		
	}

	app.core = core;
	app.user = user;
	app.data = data;
	app.core.callQQ=function(qq){
		var main = plus.android.runtimeMainActivity();
                    var Intent = plus.android.importClass('android.content.Intent');
                    var Uri = plus.android.importClass('android.net.Uri');
                    var intent = new Intent(Intent.ACTION_VIEW, Uri.parse("mqqwpa://im/chat?chat_type=wpa&uin="+qq));
                    main.startActivity(intent);
	}
	app.core.callQQGroup=function(qq){
		var main = plus.android.runtimeMainActivity();
                    var Intent = plus.android.importClass('android.content.Intent');
                    var Uri = plus.android.importClass('android.net.Uri');
                    var intent = new Intent(Intent.ACTION_VIEW, Uri.parse("mqqapi://card/show_pslcard?src_type=internal&version=1&uin="+qq+"&card_type=group&source=qrcode"));
                    main.startActivity(intent);
	}
	app.user.islogin=function(){
		var islogin;
		var userinfo=localStorage.getItem("userInfo");
			console.log("用户缓存"+localStorage.getItem("userInfo"))
			if(userinfo==null)
			{
				islogin=false;
			}else{
				islogin=true;
			}
			return islogin;
	}
	app.core.isphone=function(inputString)
		     {
		          var partten = /^1[3,5,8]\d{9}$/;
		          var fl=false;
		          if(partten.test(inputString))
		          {
		               //alert('是手机号码');
		               return true;
		          }
		          else
		          {
		               return false;
		               //alert('不是手机号码');
		          }
		     }

})(mui, window, app = window.app || {});